//*****************************************************************************************************
//  1. t@C
//		GraphDigitalData.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\fW^l\_CAONX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2008.01.01 M.Hama VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "GraphDigitalData.h"
#include "General.h"
#include <math.h>

// CSVt@C̍ږ
static const char *gTitle[] = {
	"No,Freq(Hz),X-PSD(G^2/Hz),Y-PSD(G^2/Hz),Z-PSD(G^2/Hz),G-PSD(G^2/Hz)\n",					// XyNgo͗p
	"No,Freq(Hz),X-Acceleration(G),Y-Acceleration(G),Z-Acceleration(G),G-Acceleration(G)\n"		// 1/3IN^[uo͗p
};

// CGraphDigitalData _CAO

IMPLEMENT_DYNAMIC(CGraphDigitalData, CDialogEx)

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::CGraphDigitalData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd		*pParent		[I] eEBhE|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CGraphDigitalData::CGraphDigitalData(CWnd *pParent)
	: CDialogEx(CGraphDigitalData::IDD, pParent)
	, m_nCount(0)
	, m_pX(NULL)
	, m_sCsvFName(_T(""))
	, m_nPeriod(0)
{

}

CGraphDigitalData::~CGraphDigitalData()
{
}

void CGraphDigitalData::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DATA_LIST, m_List);
	DDX_Control(pDX, IDC_BUTTON_CSV, m_Button_Csv);
}


BEGIN_MESSAGE_MAP(CGraphDigitalData, CDialogEx)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_DATA_LIST, &CGraphDigitalData::OnLvnGetdispinfoDataList)
	ON_BN_CLICKED(IDC_BUTTON_CSV, &CGraphDigitalData::OnBnClickedButtonCsv)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// c[`bv\f[^
static const SToolTipData s_aToolTip[] = {
	{IDC_BUTTON_CSV, "\Ă鐔lf[^CSVt@Cɏo͂܂B"},
	{IDCANCEL, "̃_CAO܂B"},
	{0, NULL}
};

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::SetDataInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xg\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			mode			[I]	0:XyNgf[^ó@1:1/3IN^[uf[^o
//		int			nCount			[I]	f[^
//		double		*pX				[I] Xf[^̃|C^
//		double		*pY				[I] Yf[^̃|C^
//		double		*pZ				[I] Zf[^̃|C^
//		double		*pG				[I] ̓f[^̃|C^
//		LPCSTR		title			[I] ^Cg
//		long		period			[I] o͔͈
//		double		step			[I] g̃Xebv
//		double		*pStepTable		[I] g̃e[u
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphDigitalData::SetDataInfo(int mode, int nCount, const double *pX, const double *pY, const double *pZ, const double *pG, LPCSTR title, long period, double step, const double *pStepTable)
{
	m_nMode = mode;
	m_nCount = nCount;
	m_pX = pX;
	m_pY = pY;
	m_pZ = pZ;
	m_pG = pG;
	m_nPeriod = period;
	m_fStep = step;
	m_pStepTable = pStepTable;

	if (m_pX == NULL || m_pY == NULL || m_pZ == NULL || m_pG == NULL)
		m_nCount = 0;

	m_sTitle = title;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::OnDestroy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphDigitalData::OnDestroy()
{
	CDialogEx::OnDestroy();

	EndDialog(IDCANCEL);
}


//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::OnLvnGetdispinfoDataList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		LVN_GETDISPINFObZ[Wnh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		NMHDR		*pNMHDR		[I] \
//		LRESULT		*pResult	[O] ʏ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphDigitalData::OnLvnGetdispinfoDataList(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	double fFreq;
	int nFreqDigit;
	CString sFormat;

	if (pDispInfo->item.mask & LVIF_TEXT) {
		CString str;
		switch(pDispInfo->item.iSubItem) {
		case 0:
			str.Format("%d", pDispInfo->item.iItem + 1);
			lstrcpy(pDispInfo->item.pszText, (LPCSTR)str);
			break;
		case 1:
			nFreqDigit = 3;
			switch(m_nMode) {
			case 0:
				fFreq = m_fStep * pDispInfo->item.iItem;
				break;
			case 1:
				fFreq = m_pStepTable[pDispInfo->item.iItem * 2 + 1];

				if (fFreq > 0 && fFreq < 1e-2)
					nFreqDigit = 1 - (int)floor(log10(fFreq));
				break;
			}

			sFormat.Format("%%.%df", nFreqDigit);
			str.Format(sFormat, fFreq);
			lstrcpy(pDispInfo->item.pszText, (LPCSTR)str);
			break;
		case 2:
			if (m_pX != NULL) {
				str.Format("%e", m_pX[pDispInfo->item.iItem]);
				lstrcpy(pDispInfo->item.pszText, (LPCSTR)str);
			}
			break;
		case 3:
			if (m_pY != NULL) {
				str.Format("%e", m_pY[pDispInfo->item.iItem]);
				lstrcpy(pDispInfo->item.pszText, (LPCSTR)str);
			}
			break;
		case 4:
			if (m_pZ != NULL) {
				str.Format("%e", m_pZ[pDispInfo->item.iItem]);
				lstrcpy(pDispInfo->item.pszText, (LPCSTR)str);
			}
			break;
		case 5:
			if (m_pG != NULL) {
				str.Format("%e", m_pG[pDispInfo->item.iItem]);
				lstrcpy(pDispInfo->item.pszText, (LPCSTR)str);
			}
			break;
		}
	}
	*pResult = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE
//*****************************************************************************************************
BOOL CGraphDigitalData::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// sŜIł悤ɂ
	m_List.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// Xgwb_ݒ
	SetListHeader();

	// f[^ݒ
	m_List.SetItemCount(m_nCount);

	SetWindowText(m_sTitle);

	// Rg[̈ʒu𒲐
	SetCtlPosition(IDC_DATA_LIST, 0, 0, 1, 1);
	SetCtlPosition(IDC_BUTTON_CSV, 1, 1, 1, 1);
	SetCtlPosition(IDCANCEL, 1, 1, 1, 1);

	// c[`bv\ݒ
	CGeneral::SetToolTip(m_tooltip, s_aToolTip, this);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::SetListHeader
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xgwb_ݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphDigitalData::SetListHeader()
{
	struct LIxxxOLUMN {
		char *pText;
		int fmt;
		int width;
	} tColumnData[][6] = {
		{
			// XyNg\p
			{"No", LVCFMT_LEFT, 70},
			{"Freq(Hz)", LVCFMT_LEFT, 70},
			{"X-PSD(G^2/Hz)", LVCFMT_LEFT, 120},
			{"Y-PSD(G^2/Hz)", LVCFMT_LEFT, 120},
			{"Z-PSD(G^2/Hz)", LVCFMT_LEFT, 120},
			{"G-PSD(G^2/Hz)", LVCFMT_LEFT, 120}
		}, {
			// 1/3IN^[u\p
			{"No", LVCFMT_LEFT, 70},
			{"Freq(Hz)", LVCFMT_LEFT, 70},
			{"X-Acceleration(G)", LVCFMT_LEFT, 120},
			{"Y-Acceleration(G)", LVCFMT_LEFT, 120},
			{"Z-Acceleration(G)", LVCFMT_LEFT, 120},
			{"G-Acceleration(G)", LVCFMT_LEFT, 120}
		}
	}, *pColumn;
	int i;
	LV_COLUMN lvc;

	// Jf[^
	pColumn = tColumnData[m_nMode];

	// Jݒ
	for (i = 0; i < 6; i++) {
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
		lvc.fmt = pColumn->fmt;
		lvc.pszText = pColumn->pText;
		lvc.cx = pColumn->width;
		m_List.InsertColumn(i, &lvc);
		pColumn++;
	}
}


//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::OnBnClickedButtonCsv
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CSV{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphDigitalData::OnBnClickedButtonCsv()
{
	if (m_nCount == 0)
		return;

#if 0
	if (m_Period > 60 * 60 + 1) {
		CGeneral::Alert("Ԕ͈́FPԕ܂łɂĂB");
		return;
	}
#endif

	// t@CI_CAOJ
	CFileDialog cFDlg(FALSE,
						"csv",
						"*.csv",
						 OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
						"CSV(*.csv)|*.csv|SẴt@C (*.*)|*.*||",
						this
						);
	// LZȂΉȂ
	if (cFDlg.DoModal() == IDCANCEL) {
		return;
	}

	m_sCsvFName = cFDlg.GetPathName();
	CProgressBar cProgressBar;
	// vOXo[\AʃXbhŃt@Cǂݍ
	cProgressBar.ExecProcess("t@Cݒ", 10, this, WriteFileThread);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::WriteFileThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@C݃Xbh̓
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID			pParam			[I] CDataFileNXւ̃|C^
//		CProgressBar	*pProgressBar	[I] vOXo[NXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CGraphDigitalData::WriteFileThread(LPVOID pParam, CProgressBar *pProgressBar)
{
	return ((CGraphDigitalData *)pParam)->WriteFileThread2(pProgressBar);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::WriteFileThread2
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@C݃Xbh̖{
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CProgressBar	*pProgressBar	[I] vOXo[NXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CGraphDigitalData::WriteFileThread2(CProgressBar *pProgressBar)
{
	CFile cWFile;
	int	i;
	CString str;
	double fFreq;
	int nFreqDigit;
	CString sFormat;

	// ݃t@CI[v
	if (!cWFile.Open(m_sCsvFName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite)) {
		CGeneral::Alert("݃t@C܂B");
		return FALSE;
	}

	{
		CWaitCursor	cursor;
		// f[^0łȂ΁Cwb_
		if (m_nCount != 0) {
			str = gTitle[m_nMode];
			cWFile.Write(str, str.GetLength());
		}
		// f[^[v
		for (i = 0; i < m_nCount; i++) {
			nFreqDigit = 3;
			switch(m_nMode) {
			case 0:
				fFreq = m_fStep * i;
				break;
			case 1:
				fFreq = m_pStepTable[i * 2 + 1];

				if (fFreq > 0 && fFreq < 1e-2)
					nFreqDigit = 1 - (int)floor(log10(fFreq));
				break;
			}
			sFormat.Format("%%d,%%.%df,%%e,%%e,%%e,%%e\n", nFreqDigit);
			str.Format(sFormat
					, i + 1
					, fFreq
					, m_pX[i]
					, m_pY[i]
					, m_pZ[i]
					, m_pG[i]);
			cWFile.Write(str, str.GetLength());

			if ((i % 100) == 0) {
				// vOXo[XV
				if (!pProgressBar->SetProgress((i + 1) * 10 / m_nCount)) {
					// f[^t@CN[Y
					cWFile.Close();
					return FALSE;
				}
			}
		}
		// f[^t@CN[Y
		cWFile.Close();
	}
	AfxMessageBox("CSVt@Cւ̏o͂܂B", MB_ICONINFORMATION|MB_OK);
	return TRUE;
}


//*****************************************************************************************************
//  1. ֐
//		CGraphDigitalData::PreTranslateMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEbZ[W
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MSG*	pMsg			[I] MSG\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	eNX̕Ԓl̂܂ܕԂ
//*****************************************************************************************************
BOOL CGraphDigitalData::PreTranslateMessage(MSG* pMsg)
{
	// c[`bv\邽߂̏
	switch(pMsg->message){
	case WM_LBUTTONDOWN:            
	case WM_LBUTTONUP:              
	case WM_MOUSEMOVE:
		if (m_tooltip.m_hWnd)
			m_tooltip.RelayEvent(pMsg);
		break;
	}

	return CDialogEx::PreTranslateMessage(pMsg);
}
